Wt: Wt::WMenu Class Reference

Wt 4.10.4

Loading...
Searching...
No Matches
Public Member Functions | Protected Member Functions | List of all members
Wt::WMenu Class Reference

A widget that shows a menu of options. More...

`#include <Wt/WMenu.h>`

Inheritance diagram for Wt::WMenu:
[legend]

## Public Member Functions
| WMenu ()
| Creates a new menu.
| WMenu (WStackedWidget *contentsStack)
| Creates a new menu.
| ~WMenu ()
| Destructor.
WMenuItem * | addItem (const WString &label, std::unique_ptr< WWidget > contents=nullptr, ContentLoading policy=ContentLoading::Lazy)
| Adds an item.
WMenuItem * | addItem (const std::string &iconPath, const WString &label, std::unique_ptr< WWidget > contents=nullptr, ContentLoading policy=ContentLoading::Lazy)
| Adds an item.
template<class T , class V >
WMenuItem * | addItem (const WString &text, T *target, void(V::*method)())
| Adds an item with given text, and specify a slot method to be called when the item is triggered.
template<class T , class V >
WMenuItem * | addItem (const std::string &iconPath, const WString &text, T *target, void(V::*method)())
| Adds an item with given text and icon, and specify a slot method to be called when activated.
WMenuItem * | addMenu (const WString &text, std::unique_ptr< WMenu > menu)
| Adds a submenu, with given text.
WMenuItem * | addMenu (const std::string &iconPath, const WString &text, std::unique_ptr< WMenu > menu)
| Adds a submenu, with given icon and text.
virtual WMenuItem * | addItem (std::unique_ptr< WMenuItem > item)
| Adds an item.
WMenuItem * | insertItem (int index, const WString &label, std::unique_ptr< WWidget > contents=nullptr, ContentLoading policy=ContentLoading::Lazy)
| inserts an item.
WMenuItem * | insertItem (int index, const std::string &iconPath, const WString &label, std::unique_ptr< WWidget > contents=nullptr, ContentLoading policy=ContentLoading::Lazy)
| inserts an item.
template<class T , class V >
WMenuItem * | insertItem (int index, const WString &text, T *target, void(V::*method)())
| inserts an item with given text, and specify a slot method to be called when the item is triggered.
template<class T , class V >
WMenuItem * | insertItem (int index, const std::string &iconPath, const WString &text, T *target, void(V::*method)())
| inserts an item with given text and icon, and specify a slot method to be called when activated.
WMenuItem * | insertMenu (int index, const WString &text, std::unique_ptr< WMenu > menu)
| inserts a submenu, with given text.
WMenuItem * | insertMenu (int index, const std::string &iconPath, const WString &text, std::unique_ptr< WMenu > menu)
| inserts a submenu, with given icon and text.
virtual WMenuItem * | insertItem (int index, std::unique_ptr< WMenuItem > item)
| Inserts an item.
WMenuItem * | addSeparator ()
| Adds a separator to the menu.
WMenuItem * | addSectionHeader (const WString &text)
| Adds a section header to the menu.
virtual std::unique_ptr< WMenuItem > | removeItem (WMenuItem *item)
| Removes an item.
void | select (WMenuItem *item)
| Selects an item.
void | select (int index)
| Selects an item.
Signal< WMenuItem * > & | itemSelected ()
| Signal which indicates that a new item was selected.
Signal< WMenuItem * > & | itemSelectRendered ()
| Signal which indicates that a new selected item is rendered.
void | close (WMenuItem *item)
| Closes an item.
void | close (int index)
| Closes an item.
std::vector< WMenuItem * > | items () const
| Returns the items.
Signal< WMenuItem * > & | itemClosed ()
| Signal which indicates that an item was closed.
void | setItemHidden (WMenuItem *item, bool hidden)
| Hides an item.
void | setItemHidden (int index, bool hidden)
| Hides an item.
bool | isItemHidden (WMenuItem *item) const
| Returns whether the item widget of the given item is hidden.
bool | isItemHidden (int index) const
| Returns whether the item widget of the given index is hidden.
void | setItemDisabled (WMenuItem *item, bool disabled)
| Disables an item.
void | setItemDisabled (int index, bool disabled)
| Disables an item.
bool | isItemDisabled (WMenuItem *item) const
| Returns whether the item widget of the given item is disabled.
bool | isItemDisabled (int index) const
| Returns whether the item widget of the given index is disabled.
WMenuItem * | currentItem () const
| Returns the currently selected item.
int | currentIndex () const
| Returns the index of the currently selected item.
void | setInternalPathEnabled (const std::string &basePath="")
| Enables internal paths for items.
bool | internalPathEnabled () const
| Returns whether the menu generates internal paths entries.
void | setInternalBasePath (const std::string &basePath)
| Sets the internal base path.
const std::string & | internalBasePath () const
| Returns the internal base path.
WStackedWidget * | contentsStack () const
| Returns the contents stack associated with the menu.
int | count () const
| Returns the item count.
WMenuItem * | itemAt (int index) const
| Returns the item by index.
int | indexOf (WMenuItem *item) const
| Returns the index of an item.
WMenuItem * | parentItem () const
| Returns the parent item (for a submenu)
virtual void | load () override
| Loads content just before the widget is used.
Public Member Functions inherited from Wt::WCompositeWidget
| WCompositeWidget ()
| Creates a WCompositeWidget.
| WCompositeWidget (std::unique_ptr< WWidget > implementation)
| Creates a WCompositeWidget with given implementation.
virtual std::vector< WWidget * > | children () const override
| Returns child widgets.
virtual std::unique_ptr< WWidget > | removeWidget (WWidget *widget) override
| Removes a child widget.
virtual void | setObjectName (const std::string &name) override
| Sets an object name.
virtual std::string | objectName () const override
| Returns the object name.
virtual const std::string | id () const override
| Returns the (unique) identifier for this object.
virtual void | setPositionScheme (PositionScheme scheme) override
| Sets the CSS position scheme.
virtual PositionScheme | positionScheme () const override
| Returns the CSS position scheme.
virtual void | setOffsets (const WLength &offset, WFlags< Side > sides=AllSides) override
| Sets CSS offsets for a non-statically positioned widget.
virtual WLength | offset (Side s) const override
| Returns a CSS offset.
virtual void | resize (const WLength &width, const WLength &height) override
| Resizes the widget.
virtual WLength | width () const override
| Returns the width.
virtual WLength | height () const override
| Returns the height.
virtual void | setMinimumSize (const WLength &width, const WLength &height) override
| Sets a minimum size.
virtual WLength | minimumWidth () const override
| Returns the minimum width.
virtual WLength | minimumHeight () const override
| Returns the minimum height.
virtual void | setMaximumSize (const WLength &width, const WLength &height) override
| Sets a maximum size.
virtual WLength | maximumWidth () const override
| Returns the maximum width.
virtual WLength | maximumHeight () const override
| Returns the maximum height.
virtual void | setLineHeight (const WLength &height) override
| Sets the CSS line height for contained text.
virtual WLength | lineHeight () const override
| Returns the CSS line height for contained text.
virtual void | setFloatSide (Side s) override
| Specifies a CSS float side.
virtual Side | floatSide () const override
| Returns the CSS float side.
virtual void | setClearSides (WFlags< Side > sides) override
| Sets the sides that should be cleared of floats.
virtual WFlags< Side > | clearSides () const override
| Returns the sides that should remain empty.
virtual void | setMargin (const WLength &margin, WFlags< Side > sides=AllSides) override
| Sets CSS margins around the widget.
virtual WLength | margin (Side side) const override
| Returns a CSS margin set.
virtual void | setHiddenKeepsGeometry (bool enabled) override
| Sets whether the widget keeps its geometry when hidden.
virtual bool | hiddenKeepsGeometry () const override
| Returns whether the widget keeps its geometry when hidden.
virtual void | setHidden (bool hidden, const WAnimation &animation=WAnimation()) override
| Hides or shows the widget.
virtual bool | isHidden () const override
| Returns whether the widget is set hidden.
virtual bool | isVisible () const override
| Returns whether the widget is visible.
virtual void | setDisabled (bool disabled) override
| Sets whether the widget is disabled.
virtual bool | isDisabled () const override
| Returns whether the widget is set disabled.
virtual bool | isEnabled () const override
| Returns whether the widget is enabled.
virtual void | setPopup (bool popup) override
| Lets the widget overlay over other sibling widgets.
virtual bool | isPopup () const override
| Returns whether the widget is overlayed.
virtual void | setInline (bool isInline) override
| Sets whether the widget is displayed inline or as a block.
virtual bool | isInline () const override
| Returns whether the widget is displayed inline or as block.
virtual void | setDecorationStyle (const WCssDecorationStyle &style) override
| Sets a CSS decoration style.
virtual WCssDecorationStyle & | decorationStyle () override
| Returns the decoration style of this widget.
virtual void | setStyleClass (const WString &styleClass) override
| Sets (one or more) CSS style classes.
virtual WString | styleClass () const override
| Returns the CSS style class.
virtual void | addStyleClass (const WString &styleClass, bool force=false) override
| Adds a CSS style class.
virtual void | removeStyleClass (const WString &styleClass, bool force=false) override
| Removes a CSS style class.
virtual bool | hasStyleClass (const WString &styleClass) const override
| Returns whether the widget has a style class.
virtual void | setVerticalAlignment (AlignmentFlag alignment, const WLength &length=WLength::Auto) override
| Sets the vertical alignment.
virtual AlignmentFlag | verticalAlignment () const override
| Returns the vertical alignment.
virtual WLength | verticalAlignmentLength () const override
| Returns the fixed vertical alignment that was set.
virtual void | setToolTip (const WString &text, TextFormat textFormat=TextFormat::Plain) override
| Sets a tooltip.
virtual WString | toolTip () const override
| Returns the tooltip.
virtual void | setDeferredToolTip (bool enable, TextFormat textFormat=TextFormat::Plain) override
| Enable deferred tooltip.
virtual void | refresh () override
| Refresh the widget.
virtual void | setAttributeValue (const std::string &name, const WString &value) override
| Sets an attribute value.
virtual WString | attributeValue (const std::string &name) const override
| Returns an attribute value.
virtual void | setJavaScriptMember (const std::string &name, const std::string &value) override
| Sets a JavaScript member.
virtual std::string | javaScriptMember (const std::string &name) const override
| Returns the value of a JavaScript member.
virtual void | callJavaScriptMember (const std::string &name, const std::string &args) override
| Calls a JavaScript member.
virtual bool | loaded () const override
| Returns whether this widget has been loaded.
virtual void | setCanReceiveFocus (bool enabled) override
| Sets whether the widget can receive focus.
virtual bool | canReceiveFocus () const override
| Returns whether the widget can receive focus.
virtual void | setFocus (bool focus) override
| Sets focus.
virtual bool | setFirstFocus () override
| Set focus on the widget's first descendant.
virtual bool | hasFocus () const override
| Returns whether the widget currently has the focus.
virtual void | setTabIndex (int index) override
| Sets the tab index.
virtual int | tabIndex () const override
| Returns the tab index.
virtual void | setId (const std::string &id) override
| Sets the CSS Id.
virtual WWidget * | find (const std::string &name) override
| Finds a descendent widget by name.
virtual WWidget * | findById (const std::string &name) override
| Finds a descendent widget by id.
virtual void | setSelectable (bool selectable) override
| Sets as selectable.
virtual void | doJavaScript (const std::string &js) override
| Executes the given JavaScript statements when the widget is rendered or updated.
virtual void | propagateSetEnabled (bool enabled) override
| Propagates that a widget was enabled or disabled through children.
virtual bool | scrollVisibilityEnabled () const final override
| Returns whether scroll visibility detection is enabled for this widget.
virtual void | setScrollVisibilityEnabled (bool enabled) final override
| Sets whether scroll visibility detection is enabled for this widget.
virtual int | scrollVisibilityMargin () const final override
| Returns the margin around the viewport within which the widget is considered visible.
virtual void | setScrollVisibilityMargin (int margin) final override
| Sets the margin around the viewport within which the widget is considered visible.
virtual Signal< bool > & | scrollVisibilityChanged () final override
| Signal triggered when the scroll visibility of this widget changes.
virtual bool | isScrollVisible () const final override
| Returns whether this widget is currently considered scroll visible.
virtual void | setThemeStyleEnabled (bool enabled) final override
| Sets whether theme styling for a widget is enabled or disabled.
virtual bool | isThemeStyleEnabled () const final override
| Returns whether this widget is currently styled by the chosen theme.
template<typename Widget >
std::unique_ptr< Widget > | removeWidget (Widget *widget)
| Removes a child widget.
void | setFocus ()
| Sets focus.
Public Member Functions inherited from Wt::WWidget
virtual | ~WWidget ()
| Destructor.
WWidget * | parent () const
| Returns the parent widget.
template<typename Widget >
std::unique_ptr< Widget > | removeWidget (Widget *widget)
| Removes a child widget.
std::unique_ptr< WWidget > | removeFromParent ()
| Removes the widget from its parent.
void | setWidth (const WLength &width)
| Sets the width.
void | setHeight (const WLength &height)
| Sets the height.
virtual void | positionAt (const WWidget *widget, Orientation orientation=Orientation::Vertical)
| Positions a widget next to another widget.
virtual void | toggleStyleClass (const WString &styleClass, bool add, bool force=false)
| Toggles a CSS style class.
std::string | jsRef () const
| Returns a JavaScript expression to the corresponding DOM node.
void | setFocus ()
| Sets focus.
virtual void | acceptDrops (const std::string &mimeType, const WString &hoverStyleClass=WString())
| Sets a mime type to be accepted for dropping.
virtual void | stopAcceptDrops (const std::string &mimeType)
| Indicates that a mime type is no longer accepted for dropping.
virtual void | htmlText (std::ostream &out)
| Streams the (X)HTML representation.
bool | isRendered () const
| Returns whether the widget is rendered.
void | hide ()
| Hides the widget.
void | animateHide (const WAnimation &animation)
| Hides the widget using an animation.
void | show ()
| Shows the widget.
void | animateShow (const WAnimation &animation)
| Shows the widget using an animation.
void | enable ()
| Enables the widget.
void | disable ()
| Disable thes widget.
bool | layoutSizeAware () const
| Returns whether the widget is layout size aware.
Public Member Functions inherited from Wt::WObject
void | addChild (std::unique_ptr< WObject > child)
| Add a child WObject whose lifetime is determined by this WObject.
template<typename Child >
Child * | addChild (std::unique_ptr< Child > child)
| Add a child WObject, returning a raw pointer.
std::unique_ptr< WObject > | removeChild (WObject *child)
| Remove a child WObject, so its lifetime is no longer determined by this WObject.
template<typename Child >
std::unique_ptr< Child > | removeChild (Child *child)
| Remove a child WObject, so its lifetime is no longer determined by this WObject.
void | resetLearnedSlots ()
| Resets learned stateless slot implementations.
template<class T >
void | resetLearnedSlot (void(T::*method)())
| Resets a learned stateless slot implementation.
template<class T >
WStatelessSlot * | implementStateless (void(T::*method)())
| Declares a slot to be stateless and learn client-side behaviour on first invocation.
template<class T >
WStatelessSlot * | implementStateless (void(T::*method)(), void(T::*undoMethod)())
| Declares a slot to be stateless and learn client-side behaviour in advance.
void | isNotStateless ()
| Marks the current function as not stateless.
template<class T >
WStatelessSlot * | implementJavaScript (void(T::*method)(), const std::string &jsCode)
| Provides a JavaScript implementation for a method.
Public Member Functions inherited from Wt::Core::observable
| observable () noexcept
| Default constructor.
virtual | ~observable ()
| Destructor.
template<typename... Args, typename C >
auto | bindSafe (void(C::*method)(Args...)) noexcept
| Protects a method call against object destruction.
template<typename... Args, typename C >
auto | bindSafe (void(C::*method)(Args...) const) const noexcept
| Protects a const method call against object destruction.
template<typename Function >
auto | bindSafe (const Function &function) noexcept
| Protects a function against object destruction.

## Protected Member Functions
virtual void | render (WFlags< RenderFlag > flags) override
| Renders the widget.
virtual void | internalPathChanged (const std::string &path)
| Handling of internal path changes.
virtual int | nextAfterHide (int index)
| Returns the index of the item to be selected after hides.
virtual void | select (int index, bool changePath)
| Selects an item.
Protected Member Functions inherited from Wt::WCompositeWidget
virtual void | enableAjax () override
| Progresses to an Ajax-enabled widget.
void | setImplementation (std::unique_ptr< WWidget > widget)
| Set the implementation widget.
template<typename Widget >
Widget * | setImplementation (std::unique_ptr< Widget > widget)
| Sets the implementation widget, returning a raw pointer.
template<typename W , typename... Args>
W * | setNewImplementation (Args &&... args)
| Creates the implementation widget and sets it, returning a raw pointer.
WWidget * | implementation ()
| Get the implementation widget.
virtual int | boxPadding (Orientation orientation) const override
| Returns the widget's built-in padding.
virtual int | boxBorder (Orientation orientation) const override
| Returns the widget's built-in border width.
Protected Member Functions inherited from Wt::WWidget
void | setLayoutSizeAware (bool sizeAware)
| Sets the widget to be aware of its size set by a layout manager.
virtual void | layoutSizeChanged (int width, int height)
| Virtual method that indicates a size change.
| WWidget ()
| Creates a widget.
virtual void | dropEvent (WDropEvent dropEvent)
| Handles a drop event.
void | scheduleRender (WFlags< RepaintFlag > flags=None)
| Schedules rerendering of the widget.
virtual WStatelessSlot * | getStateless (Method method) override
| On-demand stateless slot implementation.
Protected Member Functions inherited from Wt::WObject

## Additional Inherited Members
Public Types inherited from Wt::WObject
typedef void(WObject::*) | Method()
| Typedef for a WObject method without arguments.
Static Public Member Functions inherited from Wt::WWidget
static WString | tr (const char *key)
| Short hand for WString::tr()
Static Public Member Functions inherited from Wt::WObject
Static Public Attributes inherited from Wt::WWidget
Protected Types inherited from Wt::WWidget
Static Protected Attributes inherited from Wt::WWidget

## Detailed Description

A widget that shows a menu of options.

The WMenu widget offers menu navigation.

Typically, a menu is used in conjunction with a WStackedWidget (but can be used without too), where different 'contents' are stacked upon each other. Each choice in the menu (which is implemented as a WMenuItem) corresponds to a tab in the contents stack. The contents stack may contain other items, and could be shared with other WMenu instances.

When used without a contents stack, you can react to menu item selection using the itemSelected() signal, to implement some custom handling of item selection.

Usage example:

// create the stack where the contents will be located
auto contents = contentsParent->addWidget(std::make_unique<Wt::WStackedWidget>());
// create a menu
auto menu = std::make_unique<Wt::WMenu>(contents);
// add four items using the default lazy loading policy.
menu->addItem("Introduction", std::make_unique<Wt::WText>("intro"));
menu->addItem("Download", std::make_unique<Wt::WText>("Not yet available"));
menu->addItem("Demo", std::make_unique<DemoWidget>());
menu->addItem(std::make_unique<Wt::WMenuItem>("Demo2", std::make_unique<DemoWidget>()));

After construction, the first entry will be selected. At any time, it is possible to select a particular item using select().

Each item of WMenu may be closeable (see WMenuItem::setCloseable(bool). Like selection, at any time, it is possible to close a particular item using close(). You can react to close of item by using the itemClosed() signal.

The WMenu implementation offers fine-grained control on how contents should be preloaded. By default, all contents is lazy-loaded, only when needed. To improve response time, an item may also be preloaded (using addItem()). In that case, the item will be loaded in the background, before its first use. In any case, once the contents corresponding to a menu item is loaded, subsequent navigation to it is handled entirely client-side.

The WMenu may participate in the application's internal path, which lets menu items correspond to internal URLs, see setInternalPathEnabled().

The look of the items may be defined through style sheets. The default WMenuItem implementation uses four style classes to distinguish between inactivated, activated, closeable inactivated and closeable activated menu items: `"item"`, `"itemselected"`, `"citem"`, `"citemselected"`. By using CSS nested selectors, a different style may be defined for items in a different menu.

You may customize the rendering and behaviour of menu entries by specializing WMenuItem.

### CSS

The menu is rendered as a <ul>. Unless you use the bootstrap theme, you will want to customize the menu using inline or external styles to hide the bullets and provide the appropriate horizontal or vertical layout.

See also
  WMenuItem

## Constructor & Destructor Documentation

## ◆ WMenu() [1/2]

Wt::WMenu::WMenu | ( |  | ) |

Creates a new menu.

The menu is not associated with a contents stack, and thus you will want to react to the itemSelected() signal to react to menu changes.

## ◆ WMenu() [2/2]

Wt::WMenu::WMenu | ( | WStackedWidget * | contentsStack | ) |

Creates a new menu.

Construct a menu to manage the widgets in `contentsStack`.

Each menu item will manage a single widget in the `contentsStack`, making it the current widget when the menu item is activated.

## Member Function Documentation

## ◆ addItem() [1/5]

WMenuItem * Wt::WMenu::addItem | ( | const std::string & | iconPath,
|  | const WString & | label,
|  | std::unique_ptr< WWidget > | contents = nullptr,
|  | ContentLoading | policy = ContentLoading::Lazy )

Adds an item.

Adds a menu item with given `contents`, which is added to the menu's associated contents stack.

`contents` may be `0` for two reasons:

- if the menu is not associated with a contents stack, then you cannot associate a menu item with a contents widget
- or, you may have one or more items which which are not associated with a contents widget in the contents stack.

Returns the corresponding WMenuItem.

See also
  addItem(WMenuItem *)

## ◆ addItem() [2/5]

template<class T , class V >

WMenuItem * Wt::WMenu::addItem | ( | const std::string & | iconPath,
|  | const WString & | text,
|  | T * | target,
|  | void(V::* | method )() )

Adds an item with given text and icon, and specify a slot method to be called when activated.

The target and `method` are connected to the WMenuItem::triggered signal.

Note
  The icon should have a width of 16 pixels.

See also
  add(WMenuItem *)

## ◆ addItem() [3/5]

WMenuItem * Wt::WMenu::addItem | ( | const WString & | label,
|  | std::unique_ptr< WWidget > | contents = nullptr,
|  | ContentLoading | policy = ContentLoading::Lazy )

Adds an item.

Use this version of addItem() if you do not want to specify an icon for this menu item.

Returns the corresponding WMenuItem.

See also
  addItem(const std::string&, const WString&, WWidget *, ContentLoading)
  addItem(WMenuItem *)

## ◆ addItem() [4/5]

template<class T , class V >

WMenuItem * Wt::WMenu::addItem | ( | const WString & | text,
|  | T * | target,
|  | void(V::* | method )() )

Adds an item with given text, and specify a slot method to be called when the item is triggered.

The target and `method` are connected to the WMenuItem::triggered signal.

See also
  add(WMenuItem *)

## ◆ addItem() [5/5]

virtual WMenuItem * Wt::WMenu::addItem | ( | std::unique_ptr< WMenuItem > | item | ) |
| virtual

Adds an item.

Adds a menu item. Use this form to add specialized WMenuItem implementations.

See also
  addItem(const WString&, WWidget *, ContentLoading)

## ◆ addMenu() [1/2]

WMenuItem * Wt::WMenu::addMenu | ( | const std::string & | iconPath,
|  | const WString & | text,
|  | std::unique_ptr< WMenu > | menu )

Adds a submenu, with given icon and text.

Adds an item with given text and icon, that leads to a submenu `menu`.

See also
  add(WMenuItem *)

## ◆ addMenu() [2/2]

WMenuItem * Wt::WMenu::addMenu | ( | const WString & | text,
|  | std::unique_ptr< WMenu > | menu )

Adds a submenu, with given text.

Adds an item with text `text`, that leads to a submenu `menu`.

See also
  add(WMenuItem *)

## ◆ addSeparator()

WMenuItem * Wt::WMenu::addSeparator | ( |  | ) |

Adds a separator to the menu.

Adds a separator the menu.

## ◆ close() [1/2]

void Wt::WMenu::close | ( | int | index | ) |

Closes an item.

Menu items in a menu with `N` items are numbered from 0 to `N` - 1.

See also
  close(WMenuItem *)

## ◆ close() [2/2]

void Wt::WMenu::close | ( | WMenuItem * | item | ) |

Closes an item.

Close the menu item `item`. Only closeable items can be closed.

See also
  close(int), WMenuItem::close()

## ◆ currentIndex()

int Wt::WMenu::currentIndex | ( |  | ) | const

Returns the index of the currently selected item.

See also
  currentItem(), select(int)

## ◆ currentItem()

WMenuItem * Wt::WMenu::currentItem | ( |  | ) | const

Returns the currently selected item.

See also
  currentIndex(), select(WMenuItem *)

## ◆ indexOf()

int Wt::WMenu::indexOf | ( | WMenuItem * | item | ) | const

Returns the index of an item.

See also
  itemAt()

## ◆ insertItem() [1/5]

WMenuItem * Wt::WMenu::insertItem | ( | int | index,
|  | const std::string & | iconPath,
|  | const WString & | label,
|  | std::unique_ptr< WWidget > | contents = nullptr,
|  | ContentLoading | policy = ContentLoading::Lazy )

inserts an item.

inserts a menu item with given `contents`, which is inserted to the menu's associated contents stack.

`contents` may be `0` for two reasons:

- if the menu is not associated with a contents stack, then you cannot associate a menu item with a contents widget
- or, you may have one or more items which which are not associated with a contents widget in the contents stack.

Returns the corresponding WMenuItem.

See also
  insertItem(int index, WMenuItem *)

## ◆ insertItem() [2/5]

template<class T , class V >

WMenuItem * Wt::WMenu::insertItem | ( | int | index,
|  | const std::string & | iconPath,
|  | const WString & | text,
|  | T * | target,
|  | void(V::* | method )() )

inserts an item with given text and icon, and specify a slot method to be called when activated.

The target and `method` are connected to the WMenuItem::triggered signal.

Note
  The icon should have a width of 16 pixels.

See also
  insert(int index, WMenuItem *)

## ◆ insertItem() [3/5]

WMenuItem * Wt::WMenu::insertItem | ( | int | index,
|  | const WString & | label,
|  | std::unique_ptr< WWidget > | contents = nullptr,
|  | ContentLoading | policy = ContentLoading::Lazy )

inserts an item.

Use this version of insertItem() if you do not want to specify an icon for this menu item.

Returns the corresponding WMenuItem.

See also
  insertItem(int index, const std::string&, const WString&, WWidget *, ContentLoading)
  insertItem(int index, WMenuItem *)

## ◆ insertItem() [4/5]

template<class T , class V >

WMenuItem * Wt::WMenu::insertItem | ( | int | index,
|  | const WString & | text,
|  | T * | target,
|  | void(V::* | method )() )

inserts an item with given text, and specify a slot method to be called when the item is triggered.

The target and `method` are connected to the WMenuItem::triggered signal.

See also
  insert(int index,WMenuItem *)

## ◆ insertItem() [5/5]

virtual WMenuItem * Wt::WMenu::insertItem | ( | int | index,
|  | std::unique_ptr< WMenuItem > | item )
| virtual

Inserts an item.

Inserts a menu item. Use this form to insert specialized WMenuItem implementations.

See also
  insertItem(WMenuItem *item)

## ◆ insertMenu() [1/2]

WMenuItem * Wt::WMenu::insertMenu | ( | int | index,
|  | const std::string & | iconPath,
|  | const WString & | text,
|  | std::unique_ptr< WMenu > | menu )

inserts a submenu, with given icon and text.

inserts an item with given text and icon, that leads to a submenu `menu`.

See also
  insert(int index, WMenuItem *)

## ◆ insertMenu() [2/2]

WMenuItem * Wt::WMenu::insertMenu | ( | int | index,
|  | const WString & | text,
|  | std::unique_ptr< WMenu > | menu )

inserts a submenu, with given text.

inserts an item with text `text`, that leads to a submenu `menu`.

See also
  insert(int index, WMenuItem *)

## ◆ internalBasePath()

const std::string & Wt::WMenu::internalBasePath | ( |  | ) | const

Returns the internal base path.

The default value is the application's internalPath (WApplication::internalPath()) that was recorded when setInternalPathEnabled() was called, and together with each WMenuItem::pathComponent() determines the paths for each item.

For example, if internalBasePath() is `"/examples/"` and pathComponent() for a particular item is `"charts/"`, then the internal path for that item will be `"/examples/charts/"`.

See also
  setInternalPathEnabled()

## ◆ internalPathChanged()

virtual void Wt::WMenu::internalPathChanged | ( | const std::string & | path | ) |
| protectedvirtual

Handling of internal path changes.

This methods makes the menu react to internal path changes (and also the initial internal path).

You may want to reimplement this if you want to customize the internal path handling.

## ◆ internalPathEnabled()

bool Wt::WMenu::internalPathEnabled | ( |  | ) | const

Returns whether the menu generates internal paths entries.

See also
  setInternalPathEnabled()

## ◆ isItemDisabled() [1/2]

bool Wt::WMenu::isItemDisabled | ( | int | index | ) | const

Returns whether the item widget of the given index is disabled.

Menu items in a menu with `N` items are numbered from 0 to `N` - 1.

See also
  setItemDisabled()

## ◆ isItemDisabled() [2/2]

bool Wt::WMenu::isItemDisabled | ( | WMenuItem * | item | ) | const

Returns whether the item widget of the given item is disabled.

See also
  setItemDisabled()

## ◆ isItemHidden() [1/2]

bool Wt::WMenu::isItemHidden | ( | int | index | ) | const

Returns whether the item widget of the given index is hidden.

Menu items in a menu with `N` items are numbered from 0 to `N` - 1.

See also
  setItemHidden()

## ◆ isItemHidden() [2/2]

bool Wt::WMenu::isItemHidden | ( | WMenuItem * | item | ) | const

Returns whether the item widget of the given item is hidden.

See also
  setItemHidden()

## ◆ itemAt()

WMenuItem * Wt::WMenu::itemAt | ( | int | index | ) | const

Returns the item by index.

See also
  indexOf()

## ◆ itemClosed()

Signal< WMenuItem * > & Wt::WMenu::itemClosed | ( |  | ) |

Signal which indicates that an item was closed.

This signal is emitted when an item was closed. It is emitted both when the user closes an item, or when close() was invoked.

## ◆ items()

std::vector< WMenuItem * > Wt::WMenu::items | ( |  | ) | const

Returns the items.

Returns the list of menu items in this menu.

See also
  itemAt()

## ◆ itemSelected()

Signal< WMenuItem * > & Wt::WMenu::itemSelected | ( |  | ) |

Signal which indicates that a new item was selected.

This signal is emitted when an item was selected. It is emitted both when the user activated an item, or when select() was invoked.

See also
  itemSelectRendered()

## ◆ itemSelectRendered()

Signal< WMenuItem * > & Wt::WMenu::itemSelectRendered | ( |  | ) |

Signal which indicates that a new selected item is rendered.

This signal is similar to itemSelected, but is emitted from within a stateless slot. Therefore, any slot connected to this signal will be optimized to client-side JavaScript, and must support the contract of a stateless slot (i.e., be idempotent).

If you are unsure what is the difference with the itemSelected signal, you'll probably need the latter instead.

See also
  itemSelected()

## ◆ load()

virtual void Wt::WMenu::load | ( |  | ) |
| overridevirtual

Loads content just before the widget is used.

This function is called when a widget is inserted in the widget hierarchy. Widgets that get inserted in the widget hierarchy will be rendered. Visible widgets are rendered immediately, and invisible widgets in the back-ground (or not for a plain HTML session). This method is called when the widget is directly or indirectly inserted into the widget tree.

The default implementation simply propagates the load signal to its children. You may want to override this method to delay loading of resource-intensive contents.

During the life-time of a widget, this method may be called multiple times, so you should make sure that you do a deferred initialization only once.

Reimplemented from Wt::WCompositeWidget.

## ◆ nextAfterHide()

virtual int Wt::WMenu::nextAfterHide | ( | int | index | ) |
| protectedvirtual

Returns the index of the item to be selected after hides.

Returns the index of the item to be selected after the item with given index will be hidden.

By default, if the given index is an index of currently selected item, returns an index of the first visible item to the right of it. If it is not found, returns the index of the first visible item to the left of it. If there are no visible items around the currently selected item, returns the index of currently selected item.

You may want to reimplement this if you want to customize the algorithm of determining the index of the item to be selected after hiding the item with given index.

## ◆ parentItem()

WMenuItem * Wt::WMenu::parentItem | ( |  | ) | const

Returns the parent item (for a submenu)

This is the item with which this menu is associated as a submenu (if any).

## ◆ removeItem()

virtual std::unique_ptr< WMenuItem > Wt::WMenu::removeItem | ( | WMenuItem * | item | ) |
| virtual

Removes an item.

Removes the given item.

See also
  addItem()

## ◆ render()

virtual void Wt::WMenu::render | ( | WFlags< RenderFlag > | flags | ) |
| overrideprotectedvirtual

Renders the widget.

This function renders the widget (or an update for the widget), after this has been scheduled using scheduleRender().

The default implementation will render the widget by serializing changes to JavaScript and HTML. You may want to reimplement this widget if you have been postponing some of the layout / rendering implementation until the latest moment possible. In that case you should make sure you call the base implementation however.

Reimplemented from Wt::WCompositeWidget.

Reimplemented in Wt::WPopupMenu.

## ◆ select() [1/3]

void Wt::WMenu::select | ( | int | index | ) |

Selects an item.

Menu items in a menu with `N` items are numbered from 0 to `N` - 1.

Using a value of -1 removes the current selection.

See also
  select(WMenuItem *), currentIndex()

## ◆ select() [2/3]

virtual void Wt::WMenu::select | ( | int | index,
|  | bool | changePath )
| protectedvirtual

Selects an item.

This is the internal function that implements the selection logic, including optional internal path change (if `changePath` is `true`). The latter may be `false` in case an internal path change itself is the reason for selection.

## ◆ select() [3/3]

void Wt::WMenu::select | ( | WMenuItem * | item | ) |

Selects an item.

Select the menu item `item`.

When `item` is `0`, the current selection is removed.

See also
  select(int), currentItem(), WMenuItem::select()

## ◆ setInternalBasePath()

void Wt::WMenu::setInternalBasePath | ( | const std::string & | basePath | ) |

Sets the internal base path.

A '/' is appended to turn it into a folder, if needed.

See also
  setInternalPathEnabled(), internalBasePath()

## ◆ setInternalPathEnabled()

void Wt::WMenu::setInternalPathEnabled | ( | const std::string & | basePath = "" | ) |

Enables internal paths for items.

The menu participates in the internal path by changing the internal path when an item has been selected, and listening for path changes to react to path selections. As a consequence this allows the user to bookmark the current menu selection and revisit it later, use back/forward buttons to navigate through history of visited menu items, and allows indexing of pages.

For each menu item, WMenuItem::pathComponent() is appended to the `basePath`, which defaults to the internal path (WApplication::internalPath()). A '/' is appended to the base path, to turn it into a folder, if needed.

By default, menu interaction does not change the application internal path.

See also
  WMenuItem::setPathComponent().

## ◆ setItemDisabled() [1/2]

void Wt::WMenu::setItemDisabled | ( | int | index,
|  | bool | disabled )

Disables an item.

Menu items in a menu with `N` items are numbered from 0 to `N` - 1.

See also
  setItemDisabled(WMenuItem *, bool)

## ◆ setItemDisabled() [2/2]

void Wt::WMenu::setItemDisabled | ( | WMenuItem * | item,
|  | bool | disabled )

Disables an item.

Disables the menu item `item`. Only an item that is enabled can be selected. By default, all menu items are enabled.

See also
  setItemDisabled(int, bool), WMenuItem::setDisabled()

## ◆ setItemHidden() [1/2]

void Wt::WMenu::setItemHidden | ( | int | index,
|  | bool | hidden )

Hides an item.

Menu items in a menu with `N` items are numbered from 0 to `N` - 1.

See also
  setItemHidden(WMenuItem *, bool)

## ◆ setItemHidden() [2/2]

void Wt::WMenu::setItemHidden | ( | WMenuItem * | item,
|  | bool | hidden )

Hides an item.

Hides the menu item `item`. By default, all menu items are visible.

If the item was currently selected, then the next item to be selected is determined by nextAfterHide().

See also
  setItemHidden(int, bool), WMenuItem::hide()